#
# Copyright (c) 2008 University of La Reunion - France
# Author:   Pascal ANELLI
# http://personnel.univ-reunion.fr/~panelli
# All rights reserved.
# 

source global.tcl
source test-math.tcl


Class Analysis

# filter: keep the ith index in datafile
Analysis instproc init {datafile index metrics parameters xy} {
        $self instvar metrics_ lastdata_ colx_ coly_  suffixdata_
        $self instvar parameters_  index_
        
        
        set metrics_ $metrics
        set index_ $index
        set lastdata_ [exec mktemp /tmp/ns_math_${index}.XXXX] 
        
        set suffixdata_ [GetSuffix data]
        #$self default-parameter
        set parameters_ $parameters
        
        set colx_ [lindex [split $xy] 0]
        set coly_ [lindex [split $xy] 1]

        # file to proceed : datafile
        if {[catch "exec grep -n {^$} $datafile | cut -f 1 -d : " linelist]} {
            puts stderr "Inputfile is Only one block"
            exec cp -f $datafile $lastdata_
            return
        }
        # prepare the list of Number of line for each block
        set blockline [concat 1 [split $linelist]]
        lappend blockline [expr [lindex [exec wc -l $datafile] 0] +1]
        #puts stderr "-+-+>>>$blockline"
        
        # find the correct block
        set numbegin [lindex $blockline 0]
        set blocknum 0
        for {set i 1} {$i < [llength $blockline]} {incr i} {
                set numend [lindex $blockline $i]
                if { ([expr $numend - $numbegin] > 1) && ($blocknum == $index)} {
                        set numend [expr $numend - 1]
                         break
                }
                if {[expr $numend - $numbegin] > 1} {
                        incr blocknum
                }
                set numbegin  [expr $numend +1]
        }
        # do file to read in following : lastdata_
        if {$blocknum != $index} {
                puts "ERROR: Metrics on Test-analysis: Wrong number of Index"
                exit 1
        }
        #puts " CUT $datafile AT: $numbegin $numend"
        # cut the file
        set length [expr $numend - ($numbegin - 1)]
        exec head -n $numend $datafile | tail -n $length >$lastdata_
        puts stderr "\t$datafile line $numbegin to $numend : $lastdata_"
}


# Apply all the metrics on the datafile (lastdata_)
Analysis instproc MakeData {} {
        $self instvar metrics_ suffixdata_ colx_ coly_ lastdata_ parameters_
        $self instvar index_
        
        set log ""
        foreach i $metrics_ {
                puts stderr "     Computing $i"
                set ofile [exec mktemp /tmp/${i}_${index_}.XXXX]
                set math [new Math $lastdata_ $ofile $colx_ $coly_ $parameters_]
                $math $i 
                lappend log [list $i $ofile]
        }
	#exec rm -f $lastdata_
        return $log
}
