#!/bin/bash
# Call all the gnuplot scripts in a directory

export GNUTERM="aqua"

while getopts "hvf" option
do
        case $option in
                h)
                        usage
                        ;;
                v)
                        verbose=true
                        ;;
                f)
                        #export GNUTERM="postscript monochrome dashed 18"
                        export GNUTERM="postscript enhanced color eps  'Helvetica' 18"
                        ;;
                \?)
                        echo "Unkown option $option" >&2
                        usage
                        ;;
         esac
done
shift `expr $OPTIND - 1`

if [ $# -lt 1 ] ; then
        echo "Usage: $0 -f dir"
        exit 1
fi
dir=$1

pushd $dir
for i in *.gp
do
       gnuplot -persist $i
done 
popd $dir
