#!/bin/bash
# Copyright (c) 2012 University of La Reunion - France
# Author:   Pascal ANELLI
# http://personnel.univ-reunion.fr/panelli
# All rights reserved.
# Updated: sept 2018
#  
# Configure environment variable for modeling interface

#------------
NSHOME=/usr/local/src/ns-allinone-2.35

echo -e "Configure the environnement for modeling interface\n"
echo "Indicate the path of ns-allinone"
echo -n "      by default $NSHOME  (return=accept)?  "
read input
if [ -n "$input" ] ; then
        NSHOME=$input
fi
if ! [ -d "$NSHOME" ] ; then
                echo "ERROR: $NSHOME doesn't exist"
                exit 1
fi
VER=$(cat $NSHOME/ns-2.*/VERSION | cut -d'.' -f 2)


MODINT=~/modintns-2
echo "Indicate the path of modeling interface"
echo -n "      by default $MODINT (return=accept)?  "
read input
if [ -n "$input" ] ; then
       MODINT=$input 
fi

if ! [ -d "$MODINT" ] ; then
                echo "ERROR: $MODINT doesn't exist"
                exit 1
fi
if ! [ -d $MODINT/0-Lib ] ; then
        echo "ERROR: 0-Lib not found in $MODINT"
        exit 1
fi

#--------------------
rcfile=~/.modintrc
cat >|$rcfile <<EOF
export MODINT=$MODINT
export NSHOME=$NSHOME
export LIBSUITE=$MODINT/0-Lib 

# LD_LIBRARY_PATH
#OTCL_LIB=$NSHOME/otcl-1.14/
#NS2_LIB=$NSHOME/lib/
#USR_Local_LIB=/usr/local/lib/
#export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:\$OTCL_LIB:\$NS2_LIB:\$USR_Local_LIB

# TCL_LIBRARY
#TCL_LIB=$NSHOME/tcl8.5.10/library/
#USR_LIB=/usr/lib/
#export TCL_LIBRARY=$TCL_LIBRARY:\$TCL_LIB:\$USR_LIB


export LANG=POSIX
export LC_ALL=C

# PATH
#XGRAPH=$NSHOME/xgraph-12.2/:$NSHOME/bin/:$NSHOME/tcl8.5.10/unix/:$NSHOME/tk8.5.10/unix/
export NS2=$NSHOME/ns-2.$VER
#export NS=$(echo  $NSHOME/ns-2.*)
#export NAM=$(echo  $NSHOME/nam-*)

#XGRAPH=$NSHOME/xgraph-12.2/:$NSHOME/bin/:$NSHOME/tcl8*/unix/:$NSHOME/tk8*/unix/

#export PATH=.:$PATH:\$NS2:$MODINT:\$NS2/bin:\$NAM/bin:\$LIBSUITE/bin:\$LIBSUITE
export PATH=.:$PATH:\$NS2/bin:$MODINT:\$LIBSUITE/bin:\$LIBSUITE

EOF


echo " Add the line below at the end of your .bashrc:"
echo "           test -r ~/.modintrc && . ~/.modintrc"
exit 0
