#!/bin/sh
#   put together the block of differents files and make a block file
#   take the ith block in each block in order to do the ith block in the outputfile 

function usage () 
{
      echo 'Usage: sh $0 [-f] outputfile {[inputfile] | [<inpufilename]}'
      exit 1
}

byfile=false
while getopts "fF" option
do
	case $option in
		f|F)
                        byfile=true;
		        # filename=$OPTARG;
		        ;;
	esac
done
shift `expr $OPTIND - 1`
#-------------------------------------------------------

if [ $# -lt 1 ]; then 	
        usage $*
fi
outputfile="$1"
shift
if  [ -f $outputfile ]
then
        rm -f $outputfile
	#echo >>$outputfile
	#echo >>$outputfile
fi
touch $outputfile


TMPFILE="/tmp/tmpx"
rm -f ${TMPFILE}*.txt

if $byfile ; 
then
        read inputfile 
        if [ $? -gt 0 ]; then
                echo "ERROR filename empty"
                exit 1
        fi
else
        inputfile="$1"; shift
fi

while [ -n $inputfile ] ; do
        echo "+-+-+-+-+-+-+-+-+-"
        echo " $inputfile "
        echo "+-+-+-+-+-+-+-+-+-"

        blockline="0 "`grep -n '^$' $inputfile | cut -f 1 -d :`
        #set -- `wc -l $inputfile`
	lastline=`wc -l $inputfile | awk '{print $1}'`
        # Add for computation in foreach loop
        if [ `tail -n 1 $inputfile | wc -c` -ne 0 ]; then
                #echo $lastline
		lastline=`expr $lastline + 1`
                blockline=${blockline}" "${lastline}
        fi
        #echo $blockline 
        blocknum=0
        numbegin=0
        for i in $blockline ; do
                numend=$i
                #echo $numend
                if [ `expr $numend - $numbegin` -gt 1 ]; then
                        blocknum=`expr $blocknum + 1`
                        tmpfile="${TMPFILE}${blocknum}.txt"
                        if [ ! -f $tmpfile ]; then
                                touch $tmpfile
                        fi
                        # delete the last empty line
                        lastline=`expr $numend - 1`
                        length=`expr $lastline - $numbegin` 
                        head -n $lastline $inputfile | tail -n $length >>$tmpfile
                 fi
                numbegin=$numend
                #echo $numend
        done
  if $byfile ;
  then
        read inputfile 
        if [ $? -gt 0 ]
        then
                echo $inputfile
                break
        fi
  else
        if [ $# -eq 0 ] ; then
                break
        fi
        inputfile="$1"; shift
  fi
        
done

# Concat the blockfiles
for file in `ls ${TMPFILE}*`
do
        cat "$file" >>$outputfile
        echo >>$outputfile
        echo >>$outputfile
done
