#!/bin/bash

# cut a block from a file organized in blocks 
#   index begins at 0

function usage () 
{
      echo 'Usage: $0 index intputfile '
      exit 1
}


if [ $# -lt 1 ]; then 	
        usage $*
fi
if [[ $# -eq  2 && -f "$2" ]] ;
then 
#        echo "file"
        arg=$2
else
#        echo "stdin"
        arg="<&0"
        TMPFILE=$(mktemp)
        eval awk \''{print $0}'\' $arg >> $TMPFILE
        arg=$TMPFILE
fi
index=$1

blockline="0 "`eval grep -n \''^$'\' $arg | cut -f 1 -d :`
lastline=`eval wc -l $arg | awk '{print $1}'`
# Add for computation in foreach loop
if [ `eval tail -n 1 $arg | wc -c` -ne 0 ]; then
                lastline=`expr $lastline + 1`
                blockline=${blockline}" "${lastline}
fi
#echo $blockline 
blocknum=0
numbegin=0
for i in $blockline ; do
      numend=$i
      #echo $numend
      if [ `expr $numend - $numbegin` -gt 1 ]; then
                if [[ $blocknum == $index ]] ; then
                        # delete the last empty line
                        lastline=`expr $numend - 1`
                        length=`expr $lastline - $numbegin` 
                        eval head -n $lastline $arg | tail -n $length 
                fi
                blocknum=`expr $blocknum + 1`                        
      fi
      numbegin=$numend
      #echo $numend
done
