#!/bin/bash

# make a trace files with  the same set of fid in each trace file.

function usage () 
{
      echo "Usage: sh $0 \"testname\" WorkingDir Suffix"
      exit 1
}


if [ $# -ne 3 ]; then   
        echo "ERROR: Wrong number of arguments on command line"
        usage 
fi

testname=$1
wd=$2
suffix=$3

for nametest in $testname ;
do
        i="$wd/${nametest}.pkt"
	cut -d" " -f8 $i | sort -n | uniq >| /tmp/${nametest}.$suffix
done

goodfid=/tmp/goodfid
join -j 1 /tmp/*.${suffix} | sort -n >| $goodfid
tmpawk="/tmp/tmpfid.awk" 
cat >| $tmpawk <<EOF
BEGIN {
i=1
while ((getline fid < filename) > 0) {
	split(fid, a)
	fidtab[a[1]] = i
	i++
}	
}
(\$8 in fidtab) {
	print \$0
	} 
END {}
EOF

for nametest in $testname ;
do
        i="$wd/${nametest}.pkt"
	new="/tmp/${nametest}.pkt"

	awk -f $tmpawk -v filename="$goodfid" $i >| $new
	if [ -s $new ] ; then
		mv -f $new $wd/${nametest}.${suffix}
        else
		echo "ERROR empty file after goodfid"
		exit 1
	fi
done
