#!/usr/bin/python
#
# Copyright (c) 2010 University of La Reunion - France
# Author:   Pascal ANELLI
# http://personnel.univ-reunion.fr/panelli
# All rights reserved.
# 

#  Erase lines in a file according to value of a field given by a other file

#====================== Import section
import traceback, os
import tempfile
import string
from sys import stdout, stdin, stderr, exit
from optparse import OptionParser

#====================================================
# Constantes
#====================================================

#pkt trace file
#format
#    + 0.5 2 0 tcp 1250 ------- 0 2.0 3.0 0 0
FEVENT=0; FTIME=1; FINGRESS=2; FEGRESS=3; FPTYPE = 4
FPLEN=5; FFLAG=6; FFID=7; FSA=8; FDA=9; FSEQ=10; FUID=11


#====================================================
# Procedures Definition
#====================================================
def usage():
	print "Usage: python %s [options] keyfile [filename]" % sys.argv[0]
	print "  options:\n       -k <key rank>"
        print "           -v"
	sys.exit(1)


#=======================================
##                 MAIN               ##
#=======================================

parser = OptionParser(usage= 'usage: %prog [options] keyfile [filename]')

parser.add_option("-k", action='store', type='int', dest="kfield",  help='key position')
parser.add_option("-v", action='store_true', dest="inverse", help='inverse match')
parser.set_defaults(inverse=False)
parser.set_defaults(kfield=FFID+1)

(options, args) = parser.parse_args()

if len(args) < 1 :
	usage()

keyfile=args[0]
fdkey = open(keyfile, "r")
args=args[1:]
if len(args) == 0:
        fd = stdin
elif len(args) == 1:
        # Read the trace file
        filename=args[0]
        fd = open(filename, "r")
else:
	usage()
#-----------------------------------------------
lkey=[]
FKEY=options.kfield-1
#
# Phase 1: Read the keyfile 
#
for line in fdkey:
       if line.endswith("\n"):
                        line = line[:-1]
       if line == "\n":
                        continue
       if line.startswith('#'):
                        continue
       lkey.append(line)
#
#   Phase 2: Print the results
#
for line in fd:
         if line.endswith("\n"):
                          line = line[:-1]          
         if line == "\n" or line.startswith('#'):
                print line
                continue
         record=line.split()
         key=record[FKEY]
         present=bool(lkey.count(key))
         if present and not options.inverse:
                print line
         elif (not present) and options.inverse:
                print line
exit(0)
#--------------
