#!/bin/bash
#  for plot graph  according to a gnuplot script
#  gnuplot script use /tmp/curve.gp as plot instruction
#       and /tmp/gplot.data as data file

function usage ()
{
        echo "Usage: $0 [-t <term type>] <gnuplot script> <data file> ... "
        echo "term type are: aqua, X11, unknown"
        echo "               default is postscript"
        exit 1
}


export GNUPLOT_TERM="postscript enhanced color blacktext \"Helvetica\" 12"
GNUPLOT_PAUSE=0

while getopts t:T:h option
do
       case $option in
           t|T)
                export GNUPLOT_TERM=$OPTARG
                export GNUPLOT_PAUSE=-1
                ;;
            h|H)
                usage
                exit 1
                ;;
            \?)
                echo "Error: Unknown option"
                usage $*
                exit 1
                ;;
        esac
done
shift `expr $OPTIND - 1`

[ $# -lt 2 ] && { usage $* ; } 
script=$1
name=${script%.gpl};
name=${name##*/}; # erase the path
export GNUPLOT_FILE=$name.eps

shift
# convert xgraph data file to gnuplot data file
#
i=1
for item in $* ; do
        xtoplot.sh $item >|/tmp/$name$i.data
       ((i++))
done

if ((GNUPLOT_PAUSE)) ; then
        gnuplot $script 
else
        echo "Output in $GNUPLOT_FILE..."
        gnuplot $script >| $GNUPLOT_FILE
fi

exit
