#!/bin/bash

# Keep the traffic between 2 node id 
# as known as nodecasting

function usage () 
{
      echo "Usage: sh $0 casting [inputfile]"
      echo "     casting: \"src dst\""
      exit 1
}

if [ $# -lt 1 ] ; then
        usage
fi

if [[ $# -ge  2 && -f "$2" ]] ;
then 
#        echo "file"
        arg=$2
        output=$2
else
#       echo "stdin"
        arg="<&0"
fi
                                        

name=${0%.sh};
name=${name##*/}
tmpawk="/tmp/"${name}.awk 
[ -e $tmpawk ] && rm -f $tmpawk
cat  >$tmpawk <<EOF
 BEGIN {
         FEVENT=1 ; FTIME=2
         FINGRESS=3 ; FEGRESS=4
         FPTYPE=5 ; FPLEN=6
         FFLAG=7 ; FFID=8
         FSA=9 ; FDA=10
         FSEQ=11 ; FUID=12
         }
int(\$FSA) >= startnode || int(\$FSA) <= endnode || int(\$FDA) >= startnode || int(\$FDA) <= endnode  {
                print \$0
         } 
END {
    }
EOF

tmp=$(mktemp /tmp/nodecasting.XXXX)
if [[ "$1" == "*" ]] ; then
       if [[ $# -ge  2 && -f "$2" ]] ; then 
          #        echo "file"
          cat $2
       else
          #       echo "stdin"
          cat <&0
       fi
else 
       eval awk -f $tmpawk startnode=$(echo "$1" | cut -d'-' -f1) endnode=$(echo "$1" | cut -d'-' -f2)  $arg >| $tmp
fi
if [ $? -eq 0 ]; then
        if [ -z $output ] ; then
                cat $tmp
        else
                mv -f $tmp $output
        fi
        exit 0
fi
exit 1

