#!/usr/bin/tclsh
#
# Copyright (c) 2008 University of La Reunion - France
# Author:   Pascal ANELLI
# http://personnel.univ-reunion.fr/panelli
# All rights reserved.
# 


#====================================================
# Procedure 
#====================================================
proc usage {} {
        global argv0
        puts "Usage: $argv0 <ressource file> <paramname> \[tabname\]"
        puts " tabname:         param by default"
        puts "     return: value of param name by default"
        exit 1
 }

proc shelllist { str } {

eval set ll \"$str\"
set rstr ""
foreach item $ll { 
        if { [llength $item] == 1 } {
                append rstr " " $item
        } elseif {[llength $item] > 1 } {
                append rstr " " "'[shelllist $item]'"
        }
}
return "$rstr"
}

#================================================================

set tab param

#=======================================
##                 MAIN               ##
#=======================================
if { $argc < 2 } {
        puts "ERROR: Not enough of arguments"
        usage
}
set rcfile [lindex $argv 0]
set paname [lindex $argv 1]
if { $argc > 2 } {
	set tab [lindex $argv 2]
}

# Read the parameters for script file
source $rcfile
set var [format "%s(%s)" $tab $paname]

if {![info exists $var]} {
        puts stderr "ERROR: $paname is unknown in $rcfile"
        exit 1
}
#set rstring [shelllist "[set $var]" ]
eval set rstring "\$$var"
puts -nonewline "$rstring"

exit 0
#=================

