#!/usr/bin/python
#
# Copyright (c) 2011 University of La Reunion - France
# Author:   Pascal ANELLI
# http://personnel.univ-reunion.fr/panelli
# All rights reserved.
# 

#  Add a blank line after each period of time
# input format:
#      time ....
#====================== Import section
import os

from sys import stdout, stdin, stderr, exit
from optparse import OptionParser

#====================================================
# Constantes
#====================================================

FKEY=0
#====================================================
# Procedures Definition
#====================================================


#=======================================
##                 MAIN               ##
#=======================================

timetransit=0

parser = OptionParser(usage= 'usage: %prog [options] timeperiod [trace file]')
parser.set_defaults(timetransit=0)
parser.add_option("-t", action='store', type='int', dest="timetransit",  help='time transit (%default)')
parser.set_defaults(key=0)
parser.add_option("-k", action='store', type='int', dest="key",  help='index for the key')

(options, args) = parser.parse_args()

timetransit = options.timetransit
FKEY=options.key

if len(args) < 1 :
        parser.print_help()
        exit(1)

period=int(args[0])
args=args[1:]
if len(args) == 0:
        fd = stdin
elif len(args) == 1:
        # Read the trace file
        filename=args[0]
        fd = open(filename, "r")
else:
	usage()
#------------------------------------------
timeperiod=period
for line in fd:
	if line == "\n":
                        continue
	if line.startswith('#'):
                        continue
        record=line.split()
        field=float(record[FKEY])
	if int(field) < timetransit:
		continue
	if int(field) >= timetransit+timeperiod:
		print ""
		timeperiod+=period
	print line,
