#!/usr/bin/perl
# type: perl throughput.pl <trace file> <required node> <proto> <granularity>   > output file
#  Normalized Throughput is given for  1 Mbit/s
# Modified by P. ANELLI
#  Output format:
#      time throughtput sustainable-throughput

#if (values(ARGV) < 3)
#{
#   	print STDOUT "throughput.pl  <trace file> <required node> <proto> <granularity>\n";
#	exit(1);
#}

$BW=1000000 ; # 1 Mbit/s

$infile=$ARGV[0];
$tonode=$ARGV[1];
$protocol=$ARGV[2];
$granularity=$ARGV[3];

#we compute how many bytes were transmitted during time interval specified by granularity in ms
$sum=0;
$clock=0;
$cumul=0;
$count=1;

open (DATA, "<$infile")
	|| die "Can't open $infile: $!";
print STDOUT "# $tonode $protocol\n";
while (<DATA>) {
	@x = split(' ');
	while ($x[1]-$clock > $granularity)
	{
		$throughput = (($sum*8.0)/$granularity)/$BW;
		$cumul = $cumul + $throughput;
		$cumul_average = $cumul / $count;
		$count ++;
		$clock=$clock+$granularity;
		print STDOUT "$clock $throughput $cumul_average\n";
		$sum=0;
	}

	 # checking if the event corresponds to a reception
	if ($x[0] eq 'r')
	{
		  if ($x[3] eq $tonode)
		  {
		     #checking if the packet type is proto
		     if ($x[4] eq $protocol)
		      {
			$sum=$sum+$x[5];
	    	      }
		  }
	}
}
print STDOUT "\n\n";
close DATA;
exit (0);
