#!/bin/sh

# shell-script lauching ns simulation


#====================================================
# Default Parameters
#====================================================
# set parameters
# --------------



# loops parameters



#====================================================
# Procedures Definition
#====================================================
function usage () 
{
      echo 'Usage: sh $0 <parameters file>'
      exit 1
}


function generate_ressources()
{

cat >| /tmp/load.rc <<EOF
#-----------------------
# Goal:
#
#	One pattern with 1 source nodes and 1 tcp source
#	pattern detail: Bottleneck with low available bandwidth
#	access link has 1mb of BW
#
#------------------------

#   test with ns directly


#====================================================
# BEGIN of ressource attributes
#====================================================

# Default paramters

Queue set limit_ 50

#Queue/RED set mean_pktsize_ 1250
#Queue/RED set idle_pktsize_ 250

# Used when flag DEBUG is set in the command line

#-----------------------------------

#set opt(stoptime)       30
#set opt(verbose)        1
#set opt(quiet)          1
#set opt(replication)    1
#set opt(wd)             tmp

#  Network model
#==============
#
#    +---+                                          +-----+
#    |0,s|----------                    ----------- | 0,d |
#    +---+  100 Mb  \                  /   100 Mb   +-----+
#           50 ms    \     core       /    50 ms
#                     \---+      +---+
#                     | 0 |------| 1 |
#                     +---+      +---+
#                          10Mb 0ms

# Topology
#--------


#core link
set opt(corelink)   {{bw 10Mb} {tp 0} {queuesize 30}  {queuetype DropTail}}
set opt(routelength) 2


# Source pattern
#---------------

set opt(pattern) { \
		 {{hook {0 1}} \
		   {nbnode 1} \
		   {nbflow 70} \
		   {bw {{100Mb}}} \
		   {tp {{50ms 50ms} }} \
		   {type TCP} \
                   {class oneway} \
                   {sourceparam {{tcpversion TCP/Newreno} {tcpsink TCPSink} \
		                 {agentparam {\
					        {packetSize 1250} {maxcwnd 0} \
						{window 500}  {overhead 0.01} \
					     } \
				 } \
           	                }\
		   } \
                   {connection  Short} \
		   {transfersize { \
                                    {distribution Pareto} \
                                    {paramlist {{shape 1.2} \
                                                {avg  10000} } \
                                    } \
                                  }  \
                    } \
		    {starttime { \
                                   {distribution Exponential}\
                                   {paramlist {{avg 0.053}} \
                                   } \
                               }\
                   } \
		  } \
                }


# Analysis
#---------
# FID and node id begin to 0

set conf(pkt)     { \ 
	  	    {Queue { \
		            {{0 1} {length dropratioT} } \
                           } \
	  	    } \
		  }
set conf(param)  { \
		 }


set conf(parameter) {{bottlebw 10Mb}}


# Plotting
#---------
set conf(plot) { {length AverageEWMA} \
               }


#====================================================
# END of ressource attributes
#====================================================
EOF
}



#================================================================
export LC_ALL=C #For sort -n problem

#=======================================
##                 MAIN               ##
#=======================================

# Read the file with the model parameter
if [ $# -lt 1 ] ; then
        usage
fi

pfile=$1
if [ ! -e $pfile ] ; then
        echo "***ERROR: $pfile no such file or directory"
        exit 1
fi
source $pfile



# 
