#!/usr/bin/otclsh
set dir [pwd]
catch "cd $env(LIBSUITE)"
source template.rc
source global.tcl
source test-grapher.tcl
catch "cd $dir"

#------------------------------------
proc usage { argv0 ltest}  {
        puts stderr "Usage:  $argv0  [options] <metric> <filename>"
        puts stderr "options are:"
        puts stderr "      -wd  DIR             where to store the plots file"
        puts stderr "      -grapher GRAPHER     gnuplot or xgraph"
        puts stderr "      -t  TYPE             terminal type for gnuplot (x,a,e)"
        puts stderr "      -verbose FLAG        1 or 0"
        puts stderr "      -quiet FLAG          1 or 0"
	exit 1
}
#-----------------------
# Default value
set opt(verbose)   1
set opt(quiet)     0
set opt(wd)        [exec pwd]


global argc argv argv0

       if { [expr $argc % 2 ] != 0 || $argc < 2 } {
                usage $argv0
       }
       getopt opt  $argc argv
        
       cd $opt(wd)
       set graph [Grapher/$opt(grapher) create graph [lindex $argv 0] [lindex $argv 1] $opt(verbose) $opt(quiet) ] 
       $graph draw

