#!/bin/bash

# Copyright (c) 2011 University of La Reunion - France
# Author:   Pascal ANELLI
# http://personnel.univ-reunion.fr/panelli
# All rights reserved.
#

verbose=false

export GNUTERM="aqua"
term1="set terminal postscript enhanced color eps  'Helvetica' 18"

export GNUTERM="aqua"

libgpl="
reset
#
#   set environment
#
# GNUTERM
#set term postscript landscape
#set terminal postscript monochrome dashed 18
#set terminal aqua
#set terminal postscript eps enhanced color dashed  'Helvetica' 18

set encoding iso_8859_1


#
#   frame
# 
#set key on inside center top;
unset key
unset title;
set grid noytics noxtics lw 2;

#
#    axis
#
set xtics border nomirror;
set ytics border nomirror;


#
#    plotting
#
set style  data line;
#set style line 1 lt 3 lw 2 pt 11 ps 2
#set style line 2 lt 1 lw 2 pt 9 ps 2 
#set style line 3 lt 3 lw 2 pt 2
#set style line 4 lt 1 lw 2 pt 17
#set style line 5 lt 3 pt 19
#set style line 6 lt 1 pt 19
#set style line 7 lt -1 lw 2 pt 6 ps 2;

set style line 1 lt 1 lw 2 pt 1 ps 1 ; #
set style line 2 lt 3 lw 2 pt 13 ps 1 
set style line 3 lt 8 lw 3 pt 7 ps 1
#set style line 3 lt 5 lw 3 pt 7 ps 1
set style line 4 lt 2 lw 2 pt 6
#set style line 5 lt 4 lw 2 pt 12 ps 1
set style line 5 lt 9 lw 2 pt 12 ps 1
"


function vecho () {

if $verbose ; then
        echo "$*"
fi
}


function addplot () {
   local plotlib=$1
   local msg=$2
        if [ ! "$plotlib" ] ; then
                # zero length
                echo -n "$msg"
        else    
                echo -e "$plotlib,\\\\\n $msg"
        fi
}


function oname () {

local name=$1
local dir=$(dirname $name)

     x=$(basename ${name%.*})
     echo $dir/${x%_*}
}

function plot () {
# parameter: option, plotlib , outputprefix
local conf=""
local title=" " ; local xlabel="x" ; local ylabel="y"
        OPTIND=1
        while getopts "x:y:t:o:" parameter
        do
            case $parameter in
                x)
                   xlabel="$OPTARG"; 
                   ;;
                y)
                   ylabel="$OPTARG";
                   ;;
                t)
                   title="$OPTARG";
                   ;;
                o)
                   conf="$OPTARG";
                   ;;
             esac
        done
        shift `expr $OPTIND - 1`
        
local stage="$1"
local name=$2
        
cat >| $name.gp <<EOF
$libgpl
set output '$name.eps'
set xlabel "$xlabel"
set ylabel "$ylabel"
set title "$title"
$conf
plot $stage
#$term1
#replot
EOF

vecho "# Plot $name.gp"
gnuplot -persist $name.gp
}


