#!/usr/bin/otclsh
# Copyright (c) 2008 University of La Reunion - France
# Authors:   Pascal ANELLI
# http://personnel.univ-reunion.fr/panelli
# All rights reserved.
# 
#
#
# load common library
set dir [pwd]
catch "cd $env(LIBSUITE)"
source template.rc
source global.tcl
source test-suite-template.tcl ;# do nothing except create class for the rc file
source test-post-template.tcl

# add extension build by test-metric.tcl
read-extension test-metric.tcl

catch "cd $dir"

#====================================================
#              Default value
#====================================================

set debug 0

set opt(f) ""
set opt(prefix)  "" 

set opt(wd) ""
set opt(quiet)   0
set opt(verbose) 0
set opt(cleanup) 0


#====================================================
#              Procedures Definition
#====================================================

proc usage { argv0 }  {
        puts stderr "Usage: ns $argv0  \[DEBUG\] \[\{parameters\}\] -prefix <name>"
        puts stderr "\t -prefix name    : name of the files to pp"
        puts stderr "\t -f rcfile       : describe what to do"
        puts stderr "\t -wd dir         : where to find these files"
        puts stderr "\t -cleanup bool   : 0 = keep tmp files"
        puts stderr "\t -quiet bool     : 0 = draw with grapher"
        puts stderr "\t -verbose bool   : 1 =  print log messages"
        puts stderr "\tParameters: "
        puts stderr "\t\t format: -<parameter>  <value>"
        exit 1
}


#====================================================
#                       Main
#====================================================

global argc argv argv0

if {$argc < 2} {
         usage $argv0
}

if { [expr $argc % 2] == 1 } {
                set q [lindex $argv 0]
                if { $q == "DEBUG" } {
                        set debug 1
                        set argv [lrange $argv 1 end]
                        set argc [expr $argc - 1]
                }
}

# process simulation parameters in command line
getopt opt [llength $argv] argv
if {$opt(f) !=""} {
                if {![file exists $opt(f)]} {
                        set filename [format %s/%s $env(PWD) $opt(f)]
                } else {
                        set filename $opt(f)
                }
                #puts "  Read  ressources file : $env(PWD) [pwd] $opt(f)"
                source $filename
} else {
        usage $argv0
        }
if {$opt(wd) != ""} {
        if {[file exists $opt(wd)]} {
                cd $opt(wd)
        }
}
# erase the old data file
#eval exec  rm -f [glob -nocomplain *.{data,eps} ]
#set term  [open /dev/tty w]
if {$opt(verbose)} {
        puts "   ---- "
        puts "   at [exec date]"
}
set msg [setup_pprocess $opt(prefix) $opt(quiet) $opt(verbose) $opt(cleanup)]

puts -nonewline "$msg"


exit 0
#==================================================================#
