#
# Copyright (c) 2002-2005 University of La Reunion - France
# Authors:   Pascal ANELLI
#	     F HARIVELO
# http://personnel.univ-reunion.fr/panelli
# All rights reserved.
# 
# Permission to use and copy this software in source and binary forms
# is hereby granted, provided that the above copyright notice, this
# paragraph and the following disclaimer are retained in any copies
# of any part of this software and that the University of La Reunion is
# acknowledged in all documentation pertaining to any such copy
# or derivative work. The name of the University of La Reunion may not
# be used to endorse or promote products derived from this software
# without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE WARRANTIES OF 
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL 
# THE UNIVERSITY OF PARIS LA REUNION BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
# SOFTWARE.
#
#

#puts "#load test-main.tcl"


#=======================================
##                 MAIN               ##
#=======================================

#====================================================
#              Procedures Definition
#====================================================

proc usage { argv0 ltest}  {
     global opt
        puts stderr "Usage: ns $argv0  \[-testname <testname>\]  \[\{simulation parameters\}\] <rc file>"
        puts stderr "Valid <testname> : $ltest" 
        puts stderr "\tsimulation parameters: "
        puts stderr "\t\t format: -<parameter name>  <value>"
	puts stderr "\tParameters names are:"
	puts stderr "[array names opt]"
exit 1
}


#====================================================
#              Main script
#====================================================

global argv argv0               
	
        set startst "   ----\nBEGIN script file $argv0"
	set lclass [subclasslist TestSuite]
	set lcl ""
	foreach i $lclass {
		set lcl	[concat $lcl [lindex [split $i "/"] end]]	
	}
	set ltest $lcl

        # process simulation parameters in command line
        #set argv [lrange $argv 1 end]
	set argc [llength $argv]
	#if { [expr $argc % 2] == 1 } {
        #        usage $argv0 $ltest
        #}
        set rarg [getopt opt $argc  argv]

        set debug $opt(debug)
        if {$opt(verbose)} {
                set verbose $opt(verbose)
                puts "$startst"
                puts -nonewline "$rarg"
        }
        set argc [llength $argv]   
	if {$argc < 1} {
		usage $argv0 $ltest
	}
 
       # read the ressources file
	set opt(f) [lindex $argv 0]
    	source $opt(f)

       #--------------------
       # init test-suite
       #--------------------
	if { [lsearch -exact $ltest $opt(testname)] >= 0 } {
                set ts [new Test/$opt(testname)]
        } else {
                 puts stderr "Unknown test $opt(testname)"
                 usage $argv0 $ltest
        }
       #-----------------
       # run test-suite
       #-----------------
        $ts run

